diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/includes/image.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/includes/image.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/includes/image.php	2012-10-29 12:35:31.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/includes/image.php	2012-12-17 16:18:41.000000000 -0600
***************
*** 7,33 ****
   */
  
  /**
-  * Create a thumbnail from an Image given a maximum side size.
-  *
-  * This function can handle most image file formats which PHP supports. If PHP
-  * does not have the functionality to save in a file of the same format, the
-  * thumbnail will be created as a jpeg.
-  *
-  * @since 1.2.0
-  *
-  * @param mixed $file Filename of the original image, Or attachment id.
-  * @param int $max_side Maximum length of a single side for the thumbnail.
-  * @param mixed $deprecated Never used.
-  * @return string Thumbnail path on success, Error string on failure.
-  */
- function wp_create_thumbnail( $file, $max_side, $deprecated = '' ) {
- 	if ( !empty( $deprecated ) )
- 		_deprecated_argument( __FUNCTION__, '1.2' );
- 	$thumbpath = image_resize( $file, $max_side, $max_side );
- 	return apply_filters( 'wp_create_thumbnail', $thumbpath );
- }
- 
- /**
   * Crop an Image to a given size.
   *
   * @since 2.1.0
--- 7,12 ----
***************
*** 44,51 ****
--- 23,32 ----
   * @return string|WP_Error|false New filepath on success, WP_Error or false on failure.
   */
  function wp_crop_image( $src, $src_x, $src_y, $src_w, $src_h, $dst_w, $dst_h, $src_abs = false, $dst_file = false ) {
+ 	$src_file = $src;
  	if ( is_numeric( $src ) ) { // Handle int as attachment ID
  		$src_file = get_attached_file( $src );
+ 
  		if ( ! file_exists( $src_file ) ) {
  			// If the file doesn't exist, attempt a url fopen on the src link.
  			// This can occur with certain file replication plugins.
***************
*** 49,103 ****
  		if ( ! file_exists( $src_file ) ) {
  			// If the file doesn't exist, attempt a url fopen on the src link.
  			// This can occur with certain file replication plugins.
! 			$post = get_post( $src );
! 			$image_type = $post->post_mime_type;
! 			$src = load_image_to_edit( $src, $post->post_mime_type, 'full' );
  		} else {
! 			$size = @getimagesize( $src_file );
! 			$image_type = ( $size ) ? $size['mime'] : '';
! 			$src = wp_load_image( $src_file );
  		}
- 	} else {
- 		$size = @getimagesize( $src );
- 		$image_type = ( $size ) ? $size['mime'] : '';
- 		$src = wp_load_image( $src );
  	}
  
! 	if ( ! is_resource( $src ) )
! 		return new WP_Error( 'error_loading_image', $src, $src_file );
! 
! 	$dst = wp_imagecreatetruecolor( $dst_w, $dst_h );
! 
! 	if ( $src_abs ) {
! 		$src_w -= $src_x;
! 		$src_h -= $src_y;
! 	}
! 
! 	if ( function_exists( 'imageantialias' ) )
! 		imageantialias( $dst, true );
! 
! 	imagecopyresampled( $dst, $src, 0, 0, $src_x, $src_y, $dst_w, $dst_h, $src_w, $src_h );
! 
! 	imagedestroy( $src ); // Free up memory
  
  	if ( ! $dst_file )
  		$dst_file = str_replace( basename( $src_file ), 'cropped-' . basename( $src_file ), $src_file );
  
- 	if ( 'image/png' != $image_type )
- 		$dst_file = preg_replace( '/\\.[^\\.]+$/', '.jpg', $dst_file );
- 
  	// The directory containing the original file may no longer exist when
  	// using a replication plugin.
  	wp_mkdir_p( dirname( $dst_file ) );
  
  	$dst_file = dirname( $dst_file ) . '/' . wp_unique_filename( dirname( $dst_file ), basename( $dst_file ) );
  
! 	if ( 'image/png' == $image_type && imagepng( $dst, $dst_file ) )
! 		return $dst_file;
! 	elseif ( imagejpeg( $dst, $dst_file, apply_filters( 'jpeg_quality', 90, 'wp_crop_image' ) ) )
! 		return $dst_file;
! 	else
! 		return false;
  }
  
  /**
--- 30,60 ----
  		if ( ! file_exists( $src_file ) ) {
  			// If the file doesn't exist, attempt a url fopen on the src link.
  			// This can occur with certain file replication plugins.
! 			$src = _load_image_to_edit_path( $src, 'full' );
  		} else {
! 			$src = $src_file;
  		}
  	}
  
! 	$editor = wp_get_image_editor( $src );
! 	if ( is_wp_error( $editor ) )
! 		return $editor;
! 
! 	$src = $editor->crop( $src_x, $src_y, $src_w, $src_h, $dst_w, $dst_h, $src_abs );
! 	if ( is_wp_error( $src ) )
! 		return $src;
  
  	if ( ! $dst_file )
  		$dst_file = str_replace( basename( $src_file ), 'cropped-' . basename( $src_file ), $src_file );
  
  	// The directory containing the original file may no longer exist when
  	// using a replication plugin.
  	wp_mkdir_p( dirname( $dst_file ) );
  
  	$dst_file = dirname( $dst_file ) . '/' . wp_unique_filename( dirname( $dst_file ), basename( $dst_file ) );
  
! 	$result = $editor->save( $dst_file );
! 	return $dst_file;
  }
  
  /**
***************
*** 117,124 ****
  		$imagesize = getimagesize( $file );
  		$metadata['width'] = $imagesize[0];
  		$metadata['height'] = $imagesize[1];
- 		list($uwidth, $uheight) = wp_constrain_dimensions($metadata['width'], $metadata['height'], 128, 96);
- 		$metadata['hwstring_small'] = "height='$uheight' width='$uwidth'";
  
  		// Make the file path relative to the upload dir
  		$metadata['file'] = _wp_relative_upload_path($file);
--- 74,79 ----
***************
*** 144,153 ****
  
  		$sizes = apply_filters( 'intermediate_image_sizes_advanced', $sizes );
  
! 		foreach ($sizes as $size => $size_data ) {
! 			$resized = image_make_intermediate_size( $file, $size_data['width'], $size_data['height'], $size_data['crop'] );
! 			if ( $resized )
! 				$metadata['sizes'][$size] = $resized;
  		}
  
  		// fetch additional metadata from exif/iptc
--- 99,111 ----
  
  		$sizes = apply_filters( 'intermediate_image_sizes_advanced', $sizes );
  
! 		if ( $sizes ) {
! 			$editor = wp_get_image_editor( $file );
! 
! 			if ( ! is_wp_error( $editor ) )
! 				$metadata['sizes'] = $editor->multi_resize( $sizes );
! 		} else {
! 			$metadata['sizes'] = array();
  		}
  
  		// fetch additional metadata from exif/iptc
***************
*** 161,180 ****
  }
  
  /**
-  * Calculated the new dimensions for a downsampled image.
-  *
-  * @since 2.0.0
-  * @see wp_constrain_dimensions()
-  *
-  * @param int $width Current width of the image
-  * @param int $height Current height of the image
-  * @return mixed Array(height,width) of shrunk dimensions.
-  */
- function get_udims( $width, $height) {
- 	return wp_constrain_dimensions( $width, $height, 128, 96 );
- }
- 
- /**
   * Convert a fraction string to a decimal.
   *
   * @since 2.5.0
--- 119,124 ----
***************
*** 253,265 ****
  
  			// headline, "A brief synopsis of the caption."
  			if ( ! empty( $iptc['2#105'][0] ) )
! 				$meta['title'] = utf8_encode( trim( $iptc['2#105'][0] ) );
  			// title, "Many use the Title field to store the filename of the image, though the field may be used in many ways."
  			elseif ( ! empty( $iptc['2#005'][0] ) )
! 				$meta['title'] = utf8_encode( trim( $iptc['2#005'][0] ) );
  
  			if ( ! empty( $iptc['2#120'][0] ) ) { // description / legacy caption
! 				$caption = utf8_encode( trim( $iptc['2#120'][0] ) );
  				if ( empty( $meta['title'] ) ) {
  					// Assume the title is stored in 2:120 if it's short.
  					if ( strlen( $caption ) < 80 )
--- 197,209 ----
  
  			// headline, "A brief synopsis of the caption."
  			if ( ! empty( $iptc['2#105'][0] ) )
! 				$meta['title'] = trim( $iptc['2#105'][0] );
  			// title, "Many use the Title field to store the filename of the image, though the field may be used in many ways."
  			elseif ( ! empty( $iptc['2#005'][0] ) )
! 				$meta['title'] = trim( $iptc['2#005'][0] );
  
  			if ( ! empty( $iptc['2#120'][0] ) ) { // description / legacy caption
! 				$caption = trim( $iptc['2#120'][0] );
  				if ( empty( $meta['title'] ) ) {
  					// Assume the title is stored in 2:120 if it's short.
  					if ( strlen( $caption ) < 80 )
***************
*** 272,286 ****
  			}
  
  			if ( ! empty( $iptc['2#110'][0] ) ) // credit
! 				$meta['credit'] = utf8_encode(trim($iptc['2#110'][0]));
  			elseif ( ! empty( $iptc['2#080'][0] ) ) // creator / legacy byline
! 				$meta['credit'] = utf8_encode(trim($iptc['2#080'][0]));
  
  			if ( ! empty( $iptc['2#055'][0] ) and ! empty( $iptc['2#060'][0] ) ) // created date and time
  				$meta['created_timestamp'] = strtotime( $iptc['2#055'][0] . ' ' . $iptc['2#060'][0] );
  
  			if ( ! empty( $iptc['2#116'][0] ) ) // copyright
! 				$meta['copyright'] = utf8_encode( trim( $iptc['2#116'][0] ) );
  		 }
  	}
  
--- 216,230 ----
  			}
  
  			if ( ! empty( $iptc['2#110'][0] ) ) // credit
! 				$meta['credit'] = trim( $iptc['2#110'][0] );
  			elseif ( ! empty( $iptc['2#080'][0] ) ) // creator / legacy byline
! 				$meta['credit'] = trim( $iptc['2#080'][0] );
  
  			if ( ! empty( $iptc['2#055'][0] ) and ! empty( $iptc['2#060'][0] ) ) // created date and time
  				$meta['created_timestamp'] = strtotime( $iptc['2#055'][0] . ' ' . $iptc['2#060'][0] );
  
  			if ( ! empty( $iptc['2#116'][0] ) ) // copyright
! 				$meta['copyright'] = trim( $iptc['2#116'][0] );
  		 }
  	}
  
***************
*** 289,330 ****
  		$exif = @exif_read_data( $file );
  
  		if ( !empty( $exif['Title'] ) )
! 			$meta['title'] = utf8_encode( trim( $exif['Title'] ) );
  
  		if ( ! empty( $exif['ImageDescription'] ) ) {
  			if ( empty( $meta['title'] ) && strlen( $exif['ImageDescription'] ) < 80 ) {
  				// Assume the title is stored in ImageDescription
! 				$meta['title'] = utf8_encode( trim( $exif['ImageDescription'] ) );
  				if ( ! empty( $exif['COMPUTED']['UserComment'] ) && trim( $exif['COMPUTED']['UserComment'] ) != $meta['title'] )
! 					$meta['caption'] = utf8_encode( trim( $exif['COMPUTED']['UserComment'] ) );
  			} elseif ( trim( $exif['ImageDescription'] ) != $meta['title'] ) {
! 				$meta['caption'] = utf8_encode( trim( $exif['ImageDescription'] ) );
  			}
  		} elseif ( ! empty( $exif['Comments'] ) && trim( $exif['Comments'] ) != $meta['title'] ) {
! 			$meta['caption'] = utf8_encode( trim( $exif['Comments'] ) );
  		}
  
  		if ( ! empty( $exif['Artist'] ) )
! 			$meta['credit'] = utf8_encode( trim( $exif['Artist'] ) );
  		elseif ( ! empty($exif['Author'] ) )
! 			$meta['credit'] = utf8_encode( trim( $exif['Author'] ) );
  
  		if ( ! empty( $exif['Copyright'] ) )
! 			$meta['copyright'] = utf8_encode( trim( $exif['Copyright'] ) );
  		if ( ! empty($exif['FNumber'] ) )
  			$meta['aperture'] = round( wp_exif_frac2dec( $exif['FNumber'] ), 2 );
  		if ( ! empty($exif['Model'] ) )
! 			$meta['camera'] = utf8_encode( trim( $exif['Model'] ) );
  		if ( ! empty($exif['DateTimeDigitized'] ) )
  			$meta['created_timestamp'] = wp_exif_date2ts($exif['DateTimeDigitized'] );
  		if ( ! empty($exif['FocalLength'] ) )
! 			$meta['focal_length'] = wp_exif_frac2dec( $exif['FocalLength'] );
  		if ( ! empty($exif['ISOSpeedRatings'] ) ) {
  			$meta['iso'] = is_array( $exif['ISOSpeedRatings'] ) ? reset( $exif['ISOSpeedRatings'] ) : $exif['ISOSpeedRatings'];
! 			$meta['iso'] = utf8_encode( trim( $meta['iso'] ) );
  		}
  		if ( ! empty($exif['ExposureTime'] ) )
! 			$meta['shutter_speed'] = wp_exif_frac2dec( $exif['ExposureTime'] );
  	}
  
  	return apply_filters( 'wp_read_image_metadata', $meta, $file, $sourceImageType );
--- 233,279 ----
  		$exif = @exif_read_data( $file );
  
  		if ( !empty( $exif['Title'] ) )
! 			$meta['title'] = trim( $exif['Title'] );
  
  		if ( ! empty( $exif['ImageDescription'] ) ) {
  			if ( empty( $meta['title'] ) && strlen( $exif['ImageDescription'] ) < 80 ) {
  				// Assume the title is stored in ImageDescription
! 				$meta['title'] = trim( $exif['ImageDescription'] );
  				if ( ! empty( $exif['COMPUTED']['UserComment'] ) && trim( $exif['COMPUTED']['UserComment'] ) != $meta['title'] )
! 					$meta['caption'] = trim( $exif['COMPUTED']['UserComment'] );
  			} elseif ( trim( $exif['ImageDescription'] ) != $meta['title'] ) {
! 				$meta['caption'] = trim( $exif['ImageDescription'] );
  			}
  		} elseif ( ! empty( $exif['Comments'] ) && trim( $exif['Comments'] ) != $meta['title'] ) {
! 			$meta['caption'] = trim( $exif['Comments'] );
  		}
  
  		if ( ! empty( $exif['Artist'] ) )
! 			$meta['credit'] = trim( $exif['Artist'] );
  		elseif ( ! empty($exif['Author'] ) )
! 			$meta['credit'] = trim( $exif['Author'] );
  
  		if ( ! empty( $exif['Copyright'] ) )
! 			$meta['copyright'] = trim( $exif['Copyright'] );
  		if ( ! empty($exif['FNumber'] ) )
  			$meta['aperture'] = round( wp_exif_frac2dec( $exif['FNumber'] ), 2 );
  		if ( ! empty($exif['Model'] ) )
! 			$meta['camera'] = trim( $exif['Model'] );
  		if ( ! empty($exif['DateTimeDigitized'] ) )
  			$meta['created_timestamp'] = wp_exif_date2ts($exif['DateTimeDigitized'] );
  		if ( ! empty($exif['FocalLength'] ) )
! 			$meta['focal_length'] = (string) wp_exif_frac2dec( $exif['FocalLength'] );
  		if ( ! empty($exif['ISOSpeedRatings'] ) ) {
  			$meta['iso'] = is_array( $exif['ISOSpeedRatings'] ) ? reset( $exif['ISOSpeedRatings'] ) : $exif['ISOSpeedRatings'];
! 			$meta['iso'] = trim( $meta['iso'] );
  		}
  		if ( ! empty($exif['ExposureTime'] ) )
! 			$meta['shutter_speed'] = (string) wp_exif_frac2dec( $exif['ExposureTime'] );
! 	}
! 
! 	foreach ( array( 'title', 'caption', 'credit', 'copyright', 'camera', 'iso' ) as $key ) {
! 		if ( $meta[ $key ] && ! seems_utf8( $meta[ $key ] ) )
! 			$meta[ $key ] = utf8_encode( $meta[ $key ] );
  	}
  
  	return apply_filters( 'wp_read_image_metadata', $meta, $file, $sourceImageType );
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/includes/import.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/includes/import.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/includes/import.php	2012-10-29 12:35:30.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/includes/import.php	2012-12-17 16:18:41.000000000 -0600
***************
*** 89,95 ****
  	$id = wp_insert_attachment( $object, $file );
  
  	// schedule a cleanup for one day from now in case of failed import or missing wp_import_cleanup() call
! 	wp_schedule_single_event( time() + 86400, 'importer_scheduled_cleanup', array( $id ) );
  
  	return array( 'file' => $file, 'id' => $id );
  }
--- 89,185 ----
  	$id = wp_insert_attachment( $object, $file );
  
  	// schedule a cleanup for one day from now in case of failed import or missing wp_import_cleanup() call
! 	wp_schedule_single_event( time() + DAY_IN_SECONDS, 'importer_scheduled_cleanup', array( $id ) );
  
  	return array( 'file' => $file, 'id' => $id );
  }
+ 
+ /**
+  * Returns a list from WordPress.org of popular importer plugins.
+  *
+  * @since 3.5.0
+  *
+  * @return array Importers with metadata for each.
+  */
+ function wp_get_popular_importers() {
+ 	include ABSPATH . WPINC . '/version.php'; // include an unmodified $wp_version
+ 
+ 	$locale = get_locale();
+ 	$popular_importers = get_site_transient( 'popular_importers_' . $locale );
+ 
+ 	if ( ! $popular_importers ) {
+ 		$url = add_query_arg( 'locale', get_locale(), 'http://api.wordpress.org/core/importers/1.0/' );
+ 		$options = array( 'user-agent' => 'WordPress/' . $wp_version . '; ' . home_url() );
+ 		$popular_importers = maybe_unserialize( wp_remote_retrieve_body( wp_remote_get( $url, $options ) ) );
+ 
+ 		if ( is_array( $popular_importers ) )
+ 			set_site_transient( 'popular_importers_' . $locale, $popular_importers, 2 * DAY_IN_SECONDS );
+ 		else
+ 			$popular_importers = false;
+ 	}
+ 
+ 	if ( is_array( $popular_importers ) ) {
+ 		// If the data was received as translated, return it as-is.
+ 		if ( $popular_importers['translated'] )
+ 			return $popular_importers['importers'];
+ 
+ 		foreach ( $popular_importers['importers'] as &$importer ) {
+ 			$importer['description'] = translate( $importer['description'] );
+ 			if ( $importer['name'] != 'WordPress' )
+ 				$importer['name'] = translate( $importer['name'] );
+ 		}
+ 		return $popular_importers['importers'];
+ 	}
+ 
+ 	return array(
+ 		// slug => name, description, plugin slug, and register_importer() slug
+ 		'blogger' => array(
+ 			'name' => __( 'Blogger' ),
+ 			'description' => __( 'Install the Blogger importer to import posts, comments, and users from a Blogger blog.' ),
+ 			'plugin-slug' => 'blogger-importer',
+ 			'importer-id' => 'blogger',
+ 		),
+ 		'wpcat2tag' => array(
+ 			'name' => __( 'Categories and Tags Converter' ),
+ 			'description' => __( 'Install the category/tag converter to convert existing categories to tags or tags to categories, selectively.' ),
+ 			'plugin-slug' => 'wpcat2tag-importer',
+ 			'importer-id' => 'wp-cat2tag',
+ 		),
+ 		'livejournal' => array(
+ 			'name' => __( 'LiveJournal' ),
+ 			'description' => __( 'Install the LiveJournal importer to import posts from LiveJournal using their API.' ),
+ 			'plugin-slug' => 'livejournal-importer',
+ 			'importer-id' => 'livejournal',
+ 		),
+ 		'movabletype' => array(
+ 			'name' => __( 'Movable Type and TypePad' ),
+ 			'description' => __( 'Install the Movable Type importer to import posts and comments from a Movable Type or TypePad blog.' ),
+ 			'plugin-slug' => 'movabletype-importer',
+ 			'importer-id' => 'mt',
+ 		),
+ 		'opml' => array(
+ 			'name' => __( 'Blogroll' ),
+ 			'description' => __( 'Install the blogroll importer to import links in OPML format.' ),
+ 			'plugin-slug' => 'opml-importer',
+ 			'importer-id' => 'opml',
+ 		),
+ 		'rss' => array(
+ 			'name' => __( 'RSS' ),
+ 			'description' => __( 'Install the RSS importer to import posts from an RSS feed.' ),
+ 			'plugin-slug' => 'rss-importer',
+ 			'importer-id' => 'rss',
+ 		),
+ 		'tumblr' => array(
+ 			'name' => __( 'Tumblr' ),
+ 			'description' => __( 'Install the Tumblr importer to import posts &amp; media from Tumblr using their API.' ),
+ 			'plugin-slug' => 'tumblr-importer',
+ 			'importer-id' => 'tumblr',
+ 		),
+ 		'wordpress' => array(
+ 			'name' => 'WordPress',
+ 			'description' => __( 'Install the WordPress importer to import posts, pages, comments, custom fields, categories, and tags from a WordPress export file.' ),
+ 			'plugin-slug' => 'wordpress-importer',
+ 			'importer-id' => 'wordpress',
+ 		),
+ 	);
+ }
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/includes/list-table.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/includes/list-table.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/includes/list-table.php	2012-10-29 12:35:30.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/includes/list-table.php	2012-12-17 16:18:41.000000000 -0600
***************
*** 14,22 ****
   * @since 3.1.0
   *
   * @param string $class The type of the list table, which is the class name.
   * @return object|bool Object on success, false if the class does not exist.
   */
! function _get_list_table( $class ) {
  	$core_classes = array(
  		//Site Admin
  		'WP_Posts_List_Table' => 'posts',
--- 14,23 ----
   * @since 3.1.0
   *
   * @param string $class The type of the list table, which is the class name.
+  * @param array $args Optional. Arguments to pass to the class. Accepts 'screen'.
   * @return object|bool Object on success, false if the class does not exist.
   */
! function _get_list_table( $class, $args = array() ) {
  	$core_classes = array(
  		//Site Admin
  		'WP_Posts_List_Table' => 'posts',
***************
*** 39,45 ****
  	if ( isset( $core_classes[ $class ] ) ) {
  		foreach ( (array) $core_classes[ $class ] as $required )
  			require_once( ABSPATH . 'wp-admin/includes/class-wp-' . $required . '-list-table.php' );
! 		return new $class;
  	}
  
  	return false;
--- 40,54 ----
  	if ( isset( $core_classes[ $class ] ) ) {
  		foreach ( (array) $core_classes[ $class ] as $required )
  			require_once( ABSPATH . 'wp-admin/includes/class-wp-' . $required . '-list-table.php' );
! 
! 		if ( isset( $args['screen'] ) )
! 			$args['screen'] = convert_to_screen( $args['screen'] );
! 		elseif ( isset( $GLOBALS['hook_suffix'] ) )
! 			$args['screen'] = get_current_screen();
! 		else
! 			$args['screen'] = null;
! 
! 		return new $class( $args );
  	}
  
  	return false;
